<html>
<head>
    <title>Security Protocols Analysis</title>
    <link rel="stylesheet" href="../style.css">
    <link rel="stylesheet" href="../style_game_v2.css">
    <script src="../src/svg.js" type="text/javascript"></script>
    <script src="../src/Agent.js" type="text/javascript"></script>
    <script src="../src/Fact.js" type="text/javascript"></script>
    <script src="../src/NetStack.js" type="text/javascript"></script>
    <script src="../src/Command.js" type="text/javascript"></script>
    <script src="../src/ProtocolGame.js" type="text/javascript"></script>
</head>

<body onload="c1.retrieve_cmds();">

<h2>Protocol Game</h2>
<p>
    <b>Knowledge:</b> A:[s, KAS, A, B], B:[KBS, A, B],
    S:[A, B, E, KAS, KBS, KES, K] E:[A, B, KES, fake]<br>
    <b>Steps:</b>
<ol>
    <li> A -> S: A, B
    <li> S -> A: {#K, {K}KBS}KAS
    <li> A -> B: {K}KBS, {#s}K
</ol>

<p> <b>Objectives</b>: E knows the current session secret; B knows fake.

    <div class='game'>
        <div class='agents' id='agents_box1'></div>
        <div class='network' id='bar'>
            <center>Network stack</center>
            <ul id='message_list1'></ul>
        </div>
        <div id='command'>
            <center>Commands</center>
            <textarea rows='4' type='text' id='commandbox'
                      onkeydown="if (event.ctrlKey && event.keyCode == 13)
  			   document.getElementById('execute_cmds_button').click()">
      </textarea><br/>
            <button id='execute_cmds_button'
                    onclick="c1.store_cmds_and_reload(document.getElementById('commandbox').value);">Execute commands (Ctrl + Enter)</button>
            <button
                    id='add_msg_button'
                    onclick="localStorage.clear(); location.reload();">Clear all</button>
        </div>
        <div id='console_log'>
<p id='log' class='err'>
    </div>
    </div>
<div id="help">
    <h2>Command list</h2>
    <ul>
        <li><span class='cmd'>new_session()</span>: triggers the first agent in the protocol (usually A) to start a new session of the protocol; Note that for every identifier starting with the # symbol,  <span class='cmd'>new_session</span> command will create a fresh value;
        <li><span class='cmd'>transmit(id)</span>: transmits the message with the corresponding id in the stack;
        <li><span class='cmd'>block(id)</span>: blocks the message with the corresponding id in the stack;
        <li><span class='cmd'>intercept(id)</span>: intercepts the message with the corresponding id in the stack;
        <li><span class='cmd'>inject(X -> Y : msg)</span>: injects the message "msg", where "X" and "Y" are agents in the systems.
        <li><span class='cmd'>encrypt(fact, key)</span>: if E knows both <span class='cmd'>fact</span> and <span class='cmd'>key</span>, then E will know  <span class='cmd'>{fact}key</span>;
        <li><span class='cmd'>decrypt({fact}key, key)</span>: if E knows both <span class='cmd'>{fact}key</span> and <span class='cmd'>key</span>, then E will know  <span class='cmd'>fact</span>;
        <li><span class='cmd'>compromise(key)</span>: the attacker will now the key <span class='cmd'>key</span>, only if that key was used in a previous session by the main agent A.
    </ul>
</div>
    <script>

        class Sender extends Agent {

            constructor(id, facts, network) {
                super(id, facts, network);
                this.session = 0;
                this.state = 0;
            }

            // Sender has the following states
            // init: initial state, ready to send message 1
            // (in case of multiple sessions, message 3 from previous session
            // has been sent)
            // waiting_2: message 1 sent, waiting for message 2.

            process (msg, step) {
                switch (this.state) {
                    // case 0:
                    //     this.init(step); break;
                    case 1:
                        this.sendEncryptedSecret(msg, step); break;
                    default:
                        throw 'Unknown state for agent ' + this.id;
                }
            }

            getSessionSecret (step) {
                var secret = 's_' + this.session;
                this.learns(secret, step)
                return secret;
            }

            sendEncryptedSecret(msg, step) {
                let M = this.createM("{K, {K}KBS}KAS", msg.content)

                const S_K = this.encrypt(this.getSessionSecret(step), M["K"]);
                const new_msg = {
                    source: this.id, destination: 'B',
                    content: M["{K}KBS"] + ', ' + S_K
                };

                this.sendMessage(new_msg, step);
                this.state = 0;

            }

            init (step) {
                const msg = {source: this.id, destination: 'S', content: 'A, B'};
                this.sendMessage(msg, step);
                this.session++;
                this.state = 1;
            }
        }

        class Receiver extends Agent {
            constructor(id, facts, network) {
                super(id, facts, network);
                this.state = 0;
            }

            process(msg, step) {
                switch (this.state) {
                    case 0:
                        this.decryptMessage(msg, step); break;
                    default:
                        throw 'Unknown state for agent ' + this.id;

                }


            }

            decryptMessage(msg, step) {
                var facts = msg.content.getFacts();
                if (facts.length != 2) {
                    throw (this.id + ': Expecting exactly two arguments, received: ' + facts.length);
                    return;
                }

                let M = this.createM("{K}KBS, {s}K", msg.content)
                console.log(M)
                // var K_KBS = facts[0];
                // var S_K = facts[1];
                // this.learns(K_KBS);
                // this.learns(S_K);
                //
                // var K = this.decrypt(K_KBS, 'KBS', step);
                // var S = this.decrypt(S_K, K, step);
                this.step = 0;
            }

        }

        class Server extends Agent {
            constructor(id, facts, network) {
                super(id, facts, network);
                this.state = 0;
                this.key = null;
                this.session = 0;
            }


            getFreshKey(step) {
                var k = 'K_' + this.session++;
                this.learns(k, step)
                this.key = k;
                return k;
            }

            process (msg, step) {
                switch (this.state) {
                    case 0:
                        this.sendEncryptedKey(msg, step); break;
                    default:
                        throw 'Unknown state for agent ' + this.id;
                }
            }

            sendEncryptedKey(msg, step) {
                let M = this.createM("A,B", msg.content)
                let K = this.getFreshKey(step);

                let KAS = 'K' + M["A"] + 'S';
                let KBS = 'K' + M["B"] + 'S';

                var K_KBS = this.encrypt(K, KBS, step);

                var new_msg = {source:this.id, destination:M["A"],
                    content:this.encryptList([K, K_KBS], KAS, step)};
                this.sendMessage(new_msg, step);

            }

        }

        class Attacker extends Agent {
            process (msg) {
                var facts = msg.content.getFacts();
                for (var i = 0; i < facts.length; i++)
                    this.learns(facts[i]);
            }
        }

        var s1 = new NetStack('message_list1');
        var a1 = new Sender('A', ['s', 'KAS', 'A', 'B'], s1);
        var b1 = new Receiver('B', ['A', 'B', 'KBS'], s1);
        var v1 = new Server('S', ['KES', 'KAS', 'KBS', 'A', 'B', 'E'], s1);
        var e1 = new Attacker('E', ['E', 'A', 'B', 'fake', 'KES'], s1);
        s1.registerAgents([a1, b1, v1, e1]);
        s1.registerAttacker(e1);
        var c1 = new Command(s1, e1, [a1, b1, e1, v1]);

        a1.createDiv('agents_box1', 'agent');
        b1.createDiv('agents_box1', 'agent');
        v1.createDiv('agents_box1', 'agent');
        e1.createDiv('agents_box1', 'agent');

        setCurrentStep(0);

    </script>



<svg>
    <defs>
        <marker id="markerArrow" markerWidth="13" markerHeight="8" refX="2" refY="5"
                orient="auto">
            <path d="M2,2 L2,8 L10,5 L2,2" style="fill: lightslategray;" />
        </marker>
    </defs>
</svg>

<svg>
    <defs>
        <marker id="markerCircle" markerWidth="8" markerHeight="8" refX="5" refY="5">
            <circle cx="5" cy="5" r="3" style="stroke: none; fill:lightslategray;"/>
        </marker>
    </defs>
</svg>

<svg>
    <defs>
        <marker id="markerBackArrow" markerWidth="13" markerHeight="13" refX="2" refY="5"
                orient="auto">
            <path d="M8,2 L8,8 L0,5 L8,2" style="fill: lightslategray;" />
        </marker>
    </defs>
</svg>

<svg>
    <defs>
        <marker id="triangle" viewBox="0 0 10 10" refX="0" refY="5"
                markerUnits="strokeWidth" markerWidth="10"
                markerHeight="8" orient="auto">
            <path d="M 0 0 L 10 5 L 0 10 z"></path>
        </marker>
    </defs>
</svg>
</body>
</html>
